unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, StdCtrls, FileCtrl, IdFTP, Process, LCLProc, Menus, UTF8Process,
  PrintersDlgs, Types, IdFTPList;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    IdFTP1: TIdFTP;
    ListBox1: TListBox;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    PopupMenu1: TPopupMenu;
    SaveDialog1: TSaveDialog;
    TabSheet1: TTabSheet;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure ListBox1KeyPress(Sender: TObject; var Key: char);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);


  private
    procedure FtpConnect ;


  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FtpConnect ;
begin
  idftp1.Username:=edit2.Text;
  idftp1.Password:=edit3.Text;
  idftp1.Host:=edit1.Text;
  idftp1.Passive:=True;
  idftp1.Connect;
end;

procedure TForm1.Button2Click(Sender: TObject);  // download und speichern der datei
Var
datei{, Line}: String;
begin
datei := IdFTP1.DirectoryListing.Items[ListBox1.ItemIndex].FileName;
SaveDialog1.FileName := datei;
if SaveDialog1.Execute then begin
IdFTP1.Get(datei, SaveDialog1.FileName, true);
end;
end;

procedure TForm1.Button3Click(Sender: TObject);   // Übergabe des Listeneintrages an den VLC Player

var
  Player: TProcessUTF8;
  Filename: String;
  PlayerPath: String;
  PlayerParams: String;
begin
  Filename := 'ftp://' + edit2.text + ':' + edit3.text + '@' + edit1.text + edit4.Text + '/' + idftp1.DirectoryListing.Items[ListBox1.ItemIndex].FileName;
  PlayerPath := '/Applications/VLC.app/Contents/MacOS/VLC';            // für den MAC
//  PlayerPath := 'C:\Program Files\VideoLAN\VLC\vlc.exe';              // für windows
  PlayerParams := '"' + Filename + '"';
  Player:=TProcessUTF8.Create(nil);
  try
    Player.CommandLine := PlayerPath + ' ' + PlayerParams;
    Player.Execute;
  finally
    Player.Free;
  end;

end;

procedure TForm1.Button4Click(Sender: TObject);   //Mehrere Listeneinträge löschen
var
  i: Integer;
begin
  if ListBox1.SelCount > 0 then                 //Nur löschen, wenn min. ein String in der Listbox selektiert ist
    for i:=ListBox1.Items.Count - 1 downto 0 do //Alle Items durchlaufen
      if ListBox1.Selected[i] then              //Falls ausgewählt...
        ListBox1.Items.Delete(i);               //...das Item (String) löschen
                                                // Multiselect muss in Listbox1 aktiviert sein
end;

procedure TForm1.Button5Click(Sender: TObject);

begin
  FtpConnect ;
  Button5.Caption:= 'Verbunden' ;
  idftp1.ChangeDir(edit4.Text);
  idftp1.List(Listbox1.Items,'*.ts',false);

end;

procedure TForm1.Button6Click(Sender: TObject);
var
Datei:  String;

begin
if OpenDialog1.Execute then
   begin
      Datei := OpenDialog1.FileName;
      idFTP1.Put(OpenDialog1.FileName,'/media/hdd/movie/' + ExtractFileName(OpenDialog1.FileName), True);
   end
else
   ShowMessage('nix ausgewählt...');
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
  button3.Click;
end;

procedure TForm1.ListBox1DrawItem(Control: TWinControl; Index: Integer;   // Listbox selber zeichnen
  ARect: TRect; State: TOwnerDrawState);   // die prozedure muss in dem ereigniss onDrawItem   erstellt werden
var
  aColor: TColor;                       //Hintergrundfarbe
begin
  if (Index mod 2 = 0)                  //Index sagt, um welches Item es sich handelt
    then aColor:=$FFFFFF                //jedes zweite Item bekommt weiß als Hintergrundfarbe
    else aColor:=$00E8C096;               //jedes zweite Item bekommt rosa als Hintergrundfarbe
 // if odSelected in State then aColor:=$0000FF;  //Falls Item ausgewählt ist, dann rote Hintergrundfarbe
  ListBox1.Canvas.Brush.Color:=aColor;  //Hintergrundfarbe festlegen
  ListBox1.Canvas.FillRect(ARect);      //Ein ausgefülltes Rechteck zeichnen // Style muss auf  lbOwnerDrawFixed   geändert werden

  ListBox1.Canvas.Font.Bold:=false;      //Font auf "Fett" festlegen
  ListBox1.Canvas.TextRect(ARect, 2, ARect.Top+2, ListBox1.Items[Index]);  //Itemtext zeichnen
end;

procedure TForm1.ListBox1KeyPress(Sender: TObject; var Key: char);
begin
    (Sender as TComponent).Tag := 1;

  if Key = #13 then
  begin
    Key := #0;
    Button3.Click;
  end;
end;

procedure TForm1.MenuItem1Click(Sender: TObject);     // popup menü VLC starten

   var
  Player: TProcessUTF8;
  Filename: String;
  PlayerPath: String;
  PlayerParams: String;
begin
  Filename := 'ftp://' + edit2.text + ':' + edit3.text + '@' + edit1.text + edit4.Text + '/' + idftp1.DirectoryListing.Items[ListBox1.ItemIndex].FileName;
  PlayerPath := '/Applications/VLC.app/Contents/MacOS/VLC';          // für den MAC
//  PlayerPath := 'C:\Program Files\VideoLAN\VLC\vlc.exe';           // für windows
  PlayerParams := '"' + Filename + '"';
  Player:=TProcessUTF8.Create(nil);
  try
    Player.CommandLine := PlayerPath + ' ' + PlayerParams;
    Player.Execute;
  finally
    Player.Free;
  end;
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
   Var
   datei{, Line}: String;
   begin
   datei := IdFTP1.DirectoryListing.Items[ListBox1.ItemIndex].FileName;
   SaveDialog1.FileName := datei;
   if SaveDialog1.Execute then begin
   IdFTP1.Get(datei, SaveDialog1.FileName, true);
   end;

end;


end.

